﻿using Microsoft.ApplicationInsights;
using Microsoft.ApplicationInsights.Extensibility;
using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace EventListener
{
    public class Logger
    {
        TelemetryConfiguration configuration = TelemetryConfiguration.CreateDefault();
        private static Logger _instance;

        private Logger()
        {
            configuration.InstrumentationKey = "enter App Insights instrumentation key";
        }

        public static Logger Instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new Logger();
                }
                return _instance;
            }
        }

        public void LogMessage(string message)
        {
            var telemetryClient = new TelemetryClient(configuration);
            telemetryClient.TrackTrace(message);
            Console.WriteLine(message);

        }
    }
}
