import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { HttpClientModule } from '@angular/common/http';
import { HomeComponent}  from './components/home/home.component';
import { AuctionComponent } from './components/auction/auction.component';
import {AutoRefreshComponent} from './components/timer/timer.component';
import { BidComponent } from './components/bid/bid.component';
import { WinningBidsComponent} from './components/winningbids/winningbids.component';
import { MyTransactionsComponent } from './components/mytransactions/mytransactions.component';
import { FormsModule } from '@angular/forms';
import {ImageService} from './components/image/imageservice.component';
import {AlertComponent} from './components/alert/alert.component';
import {NgbModule} from '@ng-bootstrap/ng-bootstrap';
import { BrowserModule } from '@angular/platform-browser';
import { MainComponent } from './components/main/main.component';
import { AngularFontAwesomeModule } from 'angular-font-awesome';
import { BidDetailComponent } from './components/biddetail/biddetail.component';
import {MsalGuard} from "@azure/msal-angular";
import {SecurityGaurdService} from '../app/services/securitygaurd.service'
import {environment} from './environments/environment';
import { PaymentComponent } from './components/payment/payment.component';
 
//const routes: Routes = [];
const routes: Routes = [ 
  { path: 'home', component: HomeComponent, canActivate:[SecurityGaurdService]  },
  { path: 'auction', component: AuctionComponent, canActivate:[SecurityGaurdService] },
  { path: 'bid', component: BidComponent, canActivate:[SecurityGaurdService] },
  { path: 'mytransactions', component: MyTransactionsComponent, canActivate : [SecurityGaurdService] },
  { path: 'alert', component: AlertComponent}, 
  { path: 'main', component: MainComponent},
  { path: 'biddetail', component: BidDetailComponent, canActivate : [SecurityGaurdService] },
  { path: 'winningbids', component: WinningBidsComponent, canActivate: [SecurityGaurdService]},
  { path: 'makePayment', component: PaymentComponent, canActivate: [SecurityGaurdService]},
  { path:'**' , redirectTo:'main'}
];

@NgModule({
  declarations:[ MainComponent, BidDetailComponent,  AuctionComponent, HomeComponent, PaymentComponent, BidComponent, WinningBidsComponent, MyTransactionsComponent, ImageService, AlertComponent, AutoRefreshComponent],
  imports: [RouterModule.forRoot(routes), FormsModule, HttpClientModule, BrowserModule, NgbModule, AngularFontAwesomeModule],    
  exports: [RouterModule]
})
export class AppRoutingModule { }
